#!/usr/bin/python
# coding=UTF-8

import subprocess
import re
import pdb

""" pdftotext -layout -nopgbrk p1220.pdf - """


class PDFRecordFinder(object):
    def __init__(self, src, heading_exp=None):
        if not heading_exp:
            heading_exp = re.compile('\s+Record Name: (.*)')

        opts = ["pdftotext", "-layout", "-nopgbrk", src, '-']
        pdftext = subprocess.check_output(opts)
        self.textrows = pdftext.split('\n')
        self.heading_exp = heading_exp
    
    """
    @property
    def records(self):
        row_iter = iter(self.textrows)
        try:
            while 1:
                row = row_iter.next()
                if self.heading_exp.match(row):
                    record = self.extract_record(row_iter)
                    yield record
        except Exception, e:
            raise e
            #for r in self.textrows:
        #    if self.heading_exp.match(r):
        #        record = self.extract_record()
        #        yield record
    """


    def columns(self):
        results = []
        cc = ColumnCollector()
        for group in self.record_grouping():
            for row in group:
                if cc.is_next_record(row):
                    yield cc
                    cc = ColumnCollector()
                print row
                cc.add(row)



    def record_grouping(self):
        row_iter = iter(self.textrows)
        i = 0
        for row in row_iter:
            i += 1
            if self.heading_exp.match(row):
                yield self.extract_record_columns(row_iter)


    def extract_record_columns(self, row_iter):
        re_multiwhite = re.compile(r'\s{2,}')
        result = []
        full_width_text_count = 0

        for r in row_iter:
            row = r.decode('UTF-8')
            if not row:
                continue

            #if row.strip().startswith('Code'):
            #    pdb.set_trace()

            # IF LINE CONTAINS MULTIPLE WHITESPACE, IT IS PROBABLY A TABLE
            if not re_multiwhite.search(row):
                full_width_text_count += 1
                #if full_width_text_count > 2:
                #    print 'full width text count exceeded limit'
                #    return result
                continue
            
            white_ranges = [0,]
            pos = 0
            match = True
            while pos < len(row):
                match = re_multiwhite.search(row[pos:])
                if match:
                    white_ranges.append(pos + match.start())
                    white_ranges.append(pos + match.end())
                    pos += match.end()
                else:
                    white_ranges.append(len(row))
                    pos = len(row)


            row_result = []
            white_iter = iter(white_ranges)
            while white_iter:
                try:
                    start = white_iter.next()
                    end = white_iter.next()
                    if start != end:
                        row_result.append(
                            (start, row[start:end])
                        )
                
                except StopIteration:
                    white_iter = None
            print white_ranges
            yield row_result
            result.append(row_result)
             

            """
            row_result = []
            pos = 0
            while pos < len(row):
                match = re_multiwhite.search(row[pos:])
                if match and match.start() > 0:
                    row_result.append((
                        pos,
                        row[pos:pos+match.start()],))
                    pos += match.end()
                else:
                    if match:
                        pos += match.end()
                    row_result.append((pos,row[pos:]))
                    pos += len(row)
            result.append(row_result)
            row_result = []
            """
        #return result


class UnknownColumn(Exception):
    pass

class IsNextRecord(Exception):
    pass

class ColumnCollector(object):
    def __init__(self, initial=None):
        self.data = None
        pass

    def add(self, data):
        if not self.data:
            self.data = dict(data)
        else:
            if self.is_next_record(data):
                raise IsNextRecord()
            for col_id, value in data:
                self.merge_column(col_id, value)
                
    def merge_column(self, col_id, value):
        if col_id in self.data.keys():
            self.data[col_id] += ' ' + value.strip()
            
        else:        
            # try adding a wiggle room value?
            raise UnknownColumn
    
    def is_next_record(self, data):
        """
        If the first key value contains a string
        and we already have some data in the record,
        then this row is probably the beginning of
        the next field. Raise an exception and continue
        on with a fresh ColumnCollector.
        """
        first_key = dict(data).keys()[0]
        if self.data:
            print self.data.keys()[0], first_key
            return self.data.keys()[0] == first_key
        return False

        


